// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "myodbctest.h"
#include "ChildView.h"
#include "KeyTestRS.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP

	ON_BN_CLICKED(IDC_TEST, OnTest)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}


int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_btnTest.Create(_T("Test MyODBC"), WS_CHILD | WS_VISIBLE, CRect(50, 50, 150, 75), this, IDC_TEST);

	return 0;
}

void CChildView::OnTest()
{
	// connect to MySQL using MyODBC
	CDatabase db;
	VERIFY(db.OpenEx(_T("Driver={MySQL ODBC 3.51 Driver};Server=localhost;Option=298;User=root;db=test"), CDatabase::noOdbcDialog));
	
	// delete existing records from table
	db.ExecuteSQL(_T("DELETE FROM key_test"));

	// create two test records
	db.ExecuteSQL(_T("INSERT INTO key_test (key_1, key_2, key_3, data) VALUES (1, 1, 1, 1)"));
	db.ExecuteSQL(_T("INSERT INTO key_test (key_1, key_2, key_3, data) VALUES (2, 2, 2, 2)"));

	// now try searching for the second record based on the 3 keys
	CKeyTestRS rs(&db);
	rs.m_strFilter = _T("key_1 = 2 AND key_2 = 2 AND key_3 = 2");

	rs.Open(CRecordset::snapshot);
	
	// update data value
	rs.Edit();
	rs.m_data = 3;
	rs.Update();

	// requery result
	rs.Requery();

	// display result (data should be 3)
	CString strMsg;
	strMsg.Format(_T("Data found: %d"), rs.m_data);
	AfxMessageBox(strMsg, MB_OK);

	// close connection
	rs.Close();

	db.Close();
}

